;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; SMW Line-Guided Grinder (sprite 67), by imamelia
;;
;; This is a disassembly of sprite 67 in SMW, the line-guided Grinder.
;;
;; Uses first extra bit: YES
;; Uses extra property bytes: No
;;
;; If the extra bit is clear, the sprite won't disappear on even
;; X-coordinates like the original does.  Instead, it will simply move right instead
;; of left.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; defines and tables
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

XDisp:
db $F0,$00,$F0,$00

YDisp:
db $F0,$F0,$00,$00

TileProp:
db $33,$73,$B3,$F3

XOffsetLo:
db $FC,$04,$FC,$04

XOffsetHi:
db $FF,$00,$FF,$00

YOffsetLo:
db $FC,$FC,$04,$04

YOffsetHi:
db $FF,$FF,$00,$00

BitTable:
db $80,$40,$20,$10,$08,$04,$02,$01

Data1:
db $15,$15,$15,$15,$0C,$10,$10,$10
db $10,$0C,$0C,$10,$10,$10,$10,$0C
db $15,$15,$10,$10,$10,$10,$10,$10
db $10,$10,$10,$10,$10,$10,$15,$15

Data2:
db $00,$00,$00,$00,$00,$00,$01,$02
db $00,$00,$00,$00,$02,$01,$00,$00
db $00,$00,$01,$02,$01,$02,$00,$00
db $00,$00,$02,$02,$00,$00,$00,$00

SpeedTableY1:

db $00,$10,$00,$F0,$F4,$FC,$F0,$10
db $04,$0C,$0C,$00,$10,$F0,$FC,$F4
db $F0,$10,$F0,$10,$F0,$10,$F8,$F8
db $08,$08,$10,$10,$00,$00,$F0,$10
db $10,$00,$F0,$F0,$0C,$04,$10,$F0
db $00,$F4,$F4,$FC,$F0,$10,$00,$0C
db $10,$F0,$10,$00,$10,$F0,$08,$08
db $F8,$F8,$F0,$F0,$00,$00,$10,$F0

SpeedTableX1:
db $10,$00,$10,$00,$0C,$10,$04,$00
db $10,$0C,$0C,$10,$04,$00,$10,$0C
db $10,$10,$08,$08,$08,$08,$10,$10
db $10,$10,$00,$00,$10,$10,$10,$10
db $00,$F0,$00,$F0,$F4,$F0,$00,$FC
db $F0,$F4,$F4,$F0,$00,$FC,$F0,$F4
db $F0,$F0,$F8,$F8,$F8,$F8,$F0,$F0
db $F0,$F0,$00,$00,$F0,$F0,$F0,$F0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc
JSR LineGrinderInit
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LineGrinderInit:
			LDA #$38			;\ set ball n' chain radius
			STA $1594,x			;/

			LDA #$00			;\ set initial angle ($0000-$01FF)
			STA $151C,x			; | $151C is the high byte
			LDA #$00			; |
			STA $1602,x			;/ $161C is the low byte
INC $187B,x	;
LDA $7FAB10,x	; if the extra property byte 1 is set...
AND #$02
BEQ LineSpriteFix	; fix the init routine

LDA $E4,x	;
AND #$10	; if the sprite is on an odd X position...
BNE ShiftSmall	; shift it to the right 15 pixels

LDA $E4,x	; if the sprite is on an even X position...
SEC		;
SBC #$40		;
STA $E4,x		; shift it to the left
LDA $14E0,x	;
SBC #$01		; $0140 pixels
STA $14E0,x	;
BRA FinishLineSprInit 

ShiftSmall:

INC $157C,x	; make the sprite go to the left
LDA $E4,x	;
CLC		;
ADC #$0F		; shift the sprite right $0F pixels
STA $E4,x		; (without taking the high byte into account...!)     

FinishLineSprInit:

LDA #$02		;
STA $1540,x	;
RTS		;

LineSpriteFix:

LDA $E4,x		;
AND #$10		; sprite X position / $10
LSR #4			;
STA $157C,x		; into sprite direction
BRA FinishLineSprInit	;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
PHB
PHK
PLB
JSR LineGrinderMain
LDA $E4,x
PHA
SEC
SBC #$08
STA $E4,x
LDA $14E0,x
PHA
SBC #$00
STA $14E0,x
LDA $D8,x
PHA
SEC
SBC #$08
STA $D8,x
LDA $14D4,x
PHA
SBC #$00
STA $14D4,x
JSR BallnChainMain
PLA
STA $14D4,x
PLA
STA $D8,x
PLA
STA $14E0,x
PLA
STA $E4,x
PLB
RTL
              

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite 9E - Ball 'n Chain
; commented by yoshicookiezeus
;
; Uses extra bit: YES
; If the extra bit is clear, the sprite will rotate clockwise, and if it's set, it will
; rotate counterclockwise.
;
; NOTE: The palette of the sprite is hardcoded inside the ASM file. To change it, look
; for the "Properties" table. As always, the entries are in the YXCCPPPT format.
; The palette for the chain tiles is also hardcoded, and can be found on line 285.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


			!RAM_FrameCounter	= $13
			!RAM_FrameCounterB	= $14
			!RAM_ScreenBndryXLo	= $1A
			!RAM_ScreenBndryYLo	= $1C
			!RAM_MarioDirection	= $76
			!RAM_MarioSpeedX	= $7B
			!RAM_MarioSpeedY	= $7D
			!RAM_MarioXPos		= $94
			!RAM_MarioXPosHi	= $95
			!RAM_MarioYPos		= $96
			!RAM_SpritesLocked	= $9D
			!RAM_SpriteNum		= $9E
			!RAM_SpriteSpeedY	= $AA
			!RAM_SpriteSpeedX	= $B6
			!RAM_SpriteState	= $C2
			!RAM_SpriteYLo		= $D8
			!RAM_SpriteXLo		= $E4
			!OAM_DispX		= $0300
			!OAM_DispY		= $0301
			!OAM_Tile		= $0302
			!OAM_Prop		= $0303
			!OAM_Tile2DispX		= $0304
			!OAM_Tile2DispY		= $0305
			!OAM_Tile2		= $0306
			!OAM_Tile2Prop		= $0307
			!OAM_TileSize		= $0460
			!RAM_RandomByte1	= $148D
			!RAM_RandomByte2	= $148E
			!RAM_KickImgTimer	= $149A
			!RAM_SpriteYHi		= $14D4
			!RAM_SpriteXHi		= $14E0
			!RAM_Reznor1Dead	= $1520
			!RAM_Reznor2Dead	= $1521
			!RAM_Reznor3Dead	= $1522
			!RAM_Reznor4Dead	= $1523
			!RAM_DisableInter	= $154C
			!RAM_SpriteDir		= $157C
			!RAM_SprObjStatus	= $1588
			!RAM_OffscreenHorz	= $15A0
			!RAM_SprOAMIndex	= $15EA
			!RAM_SpritePal		= $15F6
			!RAM_Tweaker1662	= $1662
			!RAM_ExSpriteNum	= $170B
			!RAM_ExSpriteYLo	= $1715
			!RAM_ExSpriteXLo	= $171F
			!RAM_ExSpriteYHi	= $1729
			!RAM_ExSpriteXHi	= $1733
			!RAM_ExSprSpeedY	= $173D
			!RAM_ExSprSpeedX	= $1747
			!RAM_OffscreenVert	= $186C
			!RAM_OnYoshi		= $187A

			!RAM_ExtraBits 		= $7FAB10
			!RAM_NewSpriteNum	= $7FAB9E



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BallnChainMain:	LDA !RAM_SpritesLocked		;\ if sprites locked,
			BNE CODE_02D653			;/ branch

			LDA !RAM_ExtraBits,x		;\ use extra bits to determine direction of rotation
			LDY #$02			; | (original uses sprite x position)
			AND #$04			; |
			BNE CODE_02D63B			; |
			LDY #$FE			; |
CODE_02D63B:		TYA				; |
			LDY #$00			; |
			CMP #$00			; |
			BPL CODE_02D643			; |
			DEY				;/

CODE_02D643:		CLC				;\ update angle depending on direction of rotation
			ADC $1602,x			; | $1602,x is used to store the low byte of the ball n' chain angle
			STA $1602,x			; |
			TYA				; |
			ADC $151C,x			; | and $151C,x for the high byte
			AND #$01			; |
			STA $151C,x			; |
CODE_02D653:		LDA $151C,x			; |
			STA $01				; | $00-$01 = ball n' chain angle
			LDA $1602,x			; |
			STA $00				;/

			REP #$30			; set 16-bit mode for accumulator and registers

			LDA $00				;\ $02-$03 = ball n' chain angle + 90 degrees
			CLC				; |
			ADC #$0080			; |
			AND #$01FF			; |
			STA $02				;/

			LDA $00				;\ $04-$05 = cosines of ball n' chain angle
			AND #$00FF			; |
			ASL				; |
			TAX				; |
			LDA $07F7DB,x			; | this is SMW's trigonometry table
			STA $04				;/

			LDA $02				;\ $06-$07 = cosines of ball n' chain angle + 90 degrees = sines for ball n' chain angle
			AND #$00FF			; |
			ASL				; |
			TAX				; |
			LDA $07F7DB,x			; |
			STA $06				;/

			SEP #$30			; set 8-bit mode for accumulator and registers

			LDX $15E9			; get sprite index
			LDA $04				;\ multiply $04...
			STA $4202			; |
			LDA $1594,x			; |
			LDY $05				; |\ if $05 is 1, no need to do the multiplication
			BNE CODE_02D6A3			; |/
			STA $4203			; | ...with radius of circle ($187B,x)
			JSR CODE_02D800			;/ waste some cycles while the result is calculated
			ASL $4216			; Product/Remainder Result (Low Byte)
			LDA $4217			; Product/Remainder Result (High Byte)
			ADC #$00			
CODE_02D6A3:		LSR $01				
			BCC CODE_02D6AA			
			EOR #$FF			
			INC A				
CODE_02D6AA:		STA $04	
			LDA $06				;\ multiply $06...
			STA $4202 			; |
			LDA $1594,x			; |
			LDY $07				; |\ if $07 is 1, no need to do the multiplication
			BNE CODE_02D6C6			; |/
			STA $4203			; | ...with raidus of circle ($187B,x)
			JSR CODE_02D800			;/ waste some cycles while the result is calculated
			ASL $4216			; Product/Remainder Result (Low Byte)
			LDA $4217			; Product/Remainder Result (High Byte)
			ADC #$00			
CODE_02D6C6:		LSR $03				
			BCC CODE_02D6CD			
			EOR #$FF			
			INC A				
CODE_02D6CD:		STA $06				

			LDA !RAM_SpriteXLo,x		;\ preserve current sprite position (center of rotation)
			PHA				; |
			LDA !RAM_SpriteXHi,x		; |
			PHA				; |
			LDA !RAM_SpriteYLo,x		; |
			PHA				; |
			LDA !RAM_SpriteYHi,x		; |
			PHA				;/

			;LDY $0F86,x			; UNKNOWN RAM ADDRESS ALERT

			STZ $00				;\
			LDA $04				; |   x offset low byte
			BPL CODE_02D6E8			; |
			DEC $00				; |
CODE_02D6E8:		CLC				; |
			ADC !RAM_SpriteXLo,x		; | + x position of rotation center low byte
			STA !RAM_SpriteXLo,x		;/  = sprite x position low byte


			LDA !RAM_SpriteXHi,x		;\    x position of rotation center high byte
			ADC $00				; | + adjustment for screen boundaries
			STA !RAM_SpriteXHi,x		;/  = x position of sprite high byte

			STZ $01				;\
			LDA $06				; |   y offset low byte
			BPL CODE_02D70B			; |
			DEC $01				; |
CODE_02D70B:		CLC				; |
			ADC !RAM_SpriteYLo,x		; | + y position of rotation center low byte
			STA !RAM_SpriteYLo,x		;/  = sprite y position low byte

			LDA !RAM_SpriteYHi,x		;\    y position of center of rotation high byte
			ADC $01				; | + adjustment for screen boundaries
			STA !RAM_SpriteYHi,x		;/  = sprite y position high byte

; in between here was a check for sprite number that determined whether the sprite should act like a platform or hurt Mario, since the ball n' chain
; shares its code with the rotating platform
; if you are interested in the exact code, check all.log

			JSL $01A7DC			; interact with Mario
			JSR BallnChainGFX

			PLA				;\ retrieve sprite position (center of rotation)
			STA !RAM_SpriteYHi,x		; |
			PLA				; |
			STA !RAM_SpriteYLo,x		; |
			PLA				; |
			STA !RAM_SpriteXHi,x		; |
			PLA				; |
			STA !RAM_SpriteXLo,x		;/

			LDA $00				;\ $00 = x position of first chain tile
			CLC				; |
			ADC !RAM_ScreenBndryXLo		; |
			SEC				; |
			SBC !RAM_SpriteXLo,x		; |
			JSR CODE_02D870			; |
			CLC				; |
			ADC !RAM_SpriteXLo,x		; |
			SEC				; |
			SBC !RAM_ScreenBndryXLo		; |
			STA $00				;/

			LDA $01				;\ $01 = y position of first chain tile
			CLC				; |
			ADC !RAM_ScreenBndryYLo		; |
			SEC				; |
			SBC !RAM_SpriteYLo,x		; |
			JSR CODE_02D870			; |
			CLC				; |
			ADC !RAM_SpriteYLo,x		; |
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			STA $01				;/

			LDA $15C4,x			;\ if sprite is off-screen,
			BNE Return02D806		;/ return
			LDA !RAM_SprOAMIndex,x		;\ get new OAM index for chain tiles
			CLC				; |
			ADC #$10			; |
			TAY				;/
			PHX				; preserve sprite index

			LDA !RAM_SpriteXLo,x		;\ make backups of sprite position low bytes that are accessible
			STA $0A				; | without having the sprite index in the x register
			LDA !RAM_SpriteYLo,x 		; |
			STA $0B				;/

; yay more removed sprite number checks

			LDA #$E8			;\ $08 = chain tile number
			STA $08				;/
			LDX #$01			; setup loop

CODE_02D7AF:		LDA $00				;\ set tile x position
			STA !OAM_DispX,y		;/
			LDA $01				;\ set tile y position
			STA !OAM_DispY,y		;/
			LDA $08				;\ set tile number
			STA !OAM_Tile,y			;/
			LDA #$33			;\ set tile properties
			STA !OAM_Prop,y			;/

			LDA $00				;\ $00 = x position of next chain tile
			CLC				; |
			ADC !RAM_ScreenBndryXLo		; |
			SEC				; |
			SBC $0A				; |
			STA $00				; |
			ASL				; |
			ROR $00				; |
			LDA $00				; |
			SEC				; |
			SBC !RAM_ScreenBndryXLo		; |
			CLC				; |
			ADC $0A				; |
			STA $00				;/

			LDA $01				;\ $01 = y position of next chain tile
			CLC				; |
			ADC !RAM_ScreenBndryYLo		; |
			SEC				; |
			SBC $0B				; |
			STA $01				; |
			ASL				; |
			ROR $01				; |
			LDA $01				; |
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			CLC				; |
			ADC $0B				; |
			STA $01				;/

			INY				;\ increase OAM index by four
			INY				; |
			INY				; |
			INY				;/
			DEX				;\ if chain tiles left to draw,
			BPL CODE_02D7AF			;/ go to start of loop

			PLX				; retrieve sprite index
			LDY #$02			; the tiles drawn were 16x16
			LDA #$05			; six tiles were drawn
			JSL $01B7B3			; finish OAM write
			RTS				; return

CODE_02D800:		NOP				;\ this routine exists for the sole purpose of wasting cycles
			NOP				; | while the multiplication or division registers do their work
			NOP				; |
			NOP				; |
			NOP				; |
			NOP				;/
Return02D806:		RTS				; return

XOffset:		db $F8,$08,$F8,$08
YOffset:		db $F8,$F8,$08,$08
Tilemap:		db $EA,$EA,$EA,$EA
Properties:		db $33,$73,$B3,$F3

BallnChainGFX:		JSR GetDrawInfo
			PHX				; preserve sprite index
			LDX #$03			; setup loop

CODE_02D819:		LDA $00				;\ set tile x position
			CLC				; |
			ADC XOffset,x			; |
			STA !OAM_DispX,y		;/

			LDA $01				;\ set tile y position
			CLC				; |
			ADC YOffset,x			; |
			STA !OAM_DispY,y		;/

			LDA Tilemap,x			;\ set tile number
			STA !OAM_Tile,y			;/ this used to draw its data from the NOPs just above instead of from a proper table

			LDA Properties,x		;\ set tile properties
			STA !OAM_Prop,y			;/

			INY				;\ increase OAM index by four
			INY				; |
			INY				; |
			INY				;/

			DEX				;\ if tiles left to draw,
			BPL CODE_02D819			;/ go to start of loop

			PLX				; retrieve sprite index
			RTS				; return

CODE_02D870:		PHP				; preserve processor flags
			BPL CODE_02D876			;\ make sure value is positive
			EOR #$FF			; |
			INC A				;/
CODE_02D876:
            STA $4205			; low byte of dividend is whatever was in the accumulator when the routine was called
			STZ $4204			; high byte of dividend is zero
			LDA $1594,x			;\ divisor is half the radius of the circle 
			LSR				; |
			STA $4206			;/
			JSR CODE_02D800			; wait
			LDA $4214			;\ $0E = low byte of result
			STA $0E				;/
			LDA $4215			; noone cares about the high byte, so why is it even loaded?
            
			ASL $0E				;\ what
			ROL				; |
			ASL $0E				; |
			ROL				; |
			ASL $0E				; |
			ROL				; |
			ASL $0E				; |
			ROL				;/

			PLP				; retrieve processor flags
			BPL Return02D8A0		;\ if original value was negative,
			EOR #$FF			; | invert result
			INC A				;/
Return02D8A0:		RTS				; return














;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LineGrinderMain:

LDA $13		;
AND #$07	; every 8 frames...
ORA $1626,x	; if the sprite is moving...
ORA $9D		; and sprites are not locked...
BNE NoSound	;
LDA #$1A		; play the ticking sound effect
STA $1DF9	;
NoSound:		;

JSR GrinderGFX	; draw the sprite
JSL $01A7DC	; interact with the player
; progress directly to the line-guided sprite handler routine

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main line-guided sprite routine ($01D74D)
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LineGuideHandlerMainRt:

LDY #$02
STY $18B4
JSR SubOffScreen

LDA $C2,x	; sprite state
JSL $0086DF	; 16-bit pointer routine

dw State00	;
dw State01	;
dw State02	;

Return00:		;
RTS		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 00
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State00:

LDY #$03		;

TileCheckLoop:	;

STY $1695	;

LDA $E4,x	;
CLC		;
ADC XOffsetLo,y	;
STA $02		; set up an X position variable, 4 pixels left or right
LDA $14E0,x	;
ADC XOffsetHi,y	;
STA $03		;

LDA $D8,x	;
CLC		;
ADC YOffsetLo,y	;
STA $00		; set up a Y position variable, 4 pixels up or down
LDA $14D4,x	;
ADC YOffsetHi,y	;
STA $01		;

LDA $1540,x	; if the move timer is set...
BNE GoToPosSet	; skip the next part

LDA $00		;
AND #$F0	; sprite X position with the individual pixel nybble clear
STA $04		;
LDA $D8,x	;
AND #$F0	;
CMP $04		; if the sprite Y position is not the same as the X position...
BNE GoToPosSet	; go directly to the position setup routine

LDA $02		;
AND #$F0	; sprite Y position with the individual pixel nybble clear
STA $05		;
LDA $E4,x	;
AND #$F0	;
CMP $05		; if the sprite X position is not the same as the Y position...
BEQ DecAndLoop	; skip the position setup routine entirely and go to the end of the loop

GoToPosSet:

JSR PositionSetup	;
BNE AltIndex	;

LDA $1693	; check the low byte of the "acts like" setting of the Map16 tile that the sprite is touching
CMP #$94		;
BEQ OnOffCheck2	; if it is 94 or 95...
CMP #$95		; then it is an on/off line guide slope
BNE Continue1	;

LDA $14AF	;
BEQ DecAndLoop	;
BNE Continue1	;

OnOffCheck2:	;

LDA $14AF	;
BNE DecAndLoop	;    

Continue1:	;

LDA $1693	;
CMP #$76		; if the tile number is less than 76...
BCC DecAndLoop	;
CMP #$9A	; or greater than 99...
BCC LineGuideTiles	; then it is not a line guide tile

DecAndLoop:

LDY $1695	;
DEY		;
BPL TileCheckLoop	; loop 4 times

LDA $C2,x	; if we're running this code in sprite state 02...
CMP #$02		;
BEQ Return01	; terminate the code
LDA #$02		; if not,
STA $C2,x	; set the sprite state to 02

LDY $160E,x	; speed index
LDA $157C,x	; depending on sprite direction
BEQ NoAddToIndex	; if the sprite is moving left...
TYA		;
CLC		;
ADC #$20	; add $20 to the speed index
TAY		;
NoAddToIndex:	;
LDA SpeedTableY1,y;
BPL $01		; if the value is negative...
ASL		; left-shift it
PHY		;
ASL		; left-shift it once more...
STA $AA,x	; and store it to the sprite Y speed
PLY		;
LDA SpeedTableX1,y;
ASL		;
STA $B6,x		; set the sprite X speed
LDA #$10		;
STA $1540,x	; set the time to pause

Return01:		;
RTS		;

LineGuideTiles:

PHA		;
SEC		;
SBC #$76		; subtract 76 from the tile number so that the index begins at 00
TAY		;
PLA		; but we still want the actual tile number in A
CMP #$96		; if the tile is a line-guide end...
BCC NoAltIndex	; 

AltIndex:

LDY $160E,x	; then do this
BRA SkipChangePos	;

NoAltIndex:	;

LDA $D8,x	;
STA $08		; back up sprite position
LDA $14D4,x	;
STA $09		;
LDA $E4,x	;
STA $0A		;
LDA $14E0,x	;
STA $0B		;

LDA $00		; and then set the sprite position
STA $D8,x	;
LDA $01		; to the offset values from before
STA $14D4,x	;
LDA $02		;
STA $E4,x		;
LDA $03		;
STA $14E0,x	;

SkipChangePos:

PHB		; preserve the data bank
LDA #$07		; set the data bank to 07 (or 87)
PHA		;
PLB		;
LDA $FBF3,y	; $07FBF3-$07FC12: low byte of 16-bit pointer to line guide behaviors
STA $1FD6,x	;
LDA $FC13,y	; $07FC13-$07FC32: high byte of 16-bit pointer to line guide behaviors
STA $1528,x	;
PLB		;

LDA Data1,y	;
STA $1570,x	; not sure what this does

STZ $1534,x	;
TYA		; save the tile index
STA $160E,x	;

LDA $1540,x	; if the wait timer is set...
BNE SetState01	; change the sprite state to 01

STZ $157C,x	; set the sprite direction to right
LDA Data2,y	;
BEQ MoreSetups	;
TAY		;
LDA $D8,x	;
CPY #$01		;
BNE NoEORPixels	;
EOR #$0F		;
NoEORPixels:	;

BRA SkipLoadX	;

MoreSetups:	;

LDA $E4,x	;

SkipLoadX:

AND #$0F	;
CMP #$0A	;
BCC NoLeftDir	;
LDA $C2,x	;
CMP #$02		;
BEQ NoLeftDir	;
INC $157C,x	;
NoLeftDir:	;

LDA $D8,x	;
STA $0C		;
LDA $E4,x	;
STA $0D		;

JSR State01	;

LDA $0C		;
SEC		;
SBC $D8,x	;
CLC		;
ADC #$08	;
CMP #$10		;
BCS RestorePos2	;

LDA $0D		;
SEC		;
SBC $E4,x		;
CLC		;
ADC #$08	;
CMP #$10		;
BCS RestorePos2	;

SetState01:	;

LDA #$01		;
STA $C2,x	;
RTS		;

RestorePos2:

LDA $08		;
STA $D8,x	; set the sprite position
LDA $09		; to the values we stored before
STA $14D4,x	;
LDA $0A		;
STA $E4,x		;
LDA $0B		;
STA $14E0,x	;  

JMP DecAndLoop

PositionSetup:	; Some Map16-checking stuff.  I'm not even going to bother trying to comment this.

LDA $00		;
AND #$F0	;
STA $06		;
LDA $02		;
LSR #4		;
PHA		;
ORA $06		;
PHA		;
LDA $5B		;
AND #$01	;
BEQ Map16HLevel	;

Map16VLevel:	;

PLA		;
LDX $01		;
CLC		;
ADC $00BA80,x	;
STA $05		;
LDA $00BABC,x	;
ADC $03		;
STA $06		;
BRA Map16Continue	;

Map16HLevel:

PLA		;
LDX $03		;
CLC		;
ADC $00BA60,x	;
STA $05		;
LDA $00BA9C,x	;
ADC $01		;
STA $06		;

Map16Continue:
LDA #$7E		; bank byte of pointer to tile low byte = $7E
STA $07		;
LDX $15E9	;
LDA [$05]		;
STA $1693	;
INC $07		; bank byte of pointer to tile low byte = $7F
LDA [$05]		;
PLY		;
STY $05		;
PHA		;
LDA $05		;
AND #$07	;
TAY		;
PLA		;
AND BitTable,y	; $018000
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 01
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State01:

LDA $9D		;
BNE Return02	; return if sprites are locked
LDA $157C,x	;
BNE State01Left	; run a slightly different routine if the sprite is facing left

State01Right:

LDY $1534,x	;

JSR MoveSprPos	;

INC $1534,x	;
LDA $187B,x	; if this sprite table is set...
BEQ SkipFrameChk1	;
LDA $13		;
LSR		;
BCC SkipFrameChk1	; then the frame counter increments again every other frame
INC $1534,x	;
SkipFrameChk1:	;

LDA $1534,x	;
CMP $1570,x	; if the first counter equals the second...
BCC Return02	;
STZ $C2,x	; reset the sprite state

Return02:		;
RTS

State01Left:	;

LDY $1570,x	;
DEY		;

JSR MoveSprPos	;

DEC $1570,x	; if this counter has reached 0...
BEQ SetState00	; set the sprite state to 00
LDA $187B,x	;
BEQ Return02	; if this sprite table is set...
LDA $13		;
LSR		;
BCC Return02	; then the counter decrements again every other frame
DEC $1570,x	;
BNE Return02	;

SetState00:	;

STZ $C2,x	;
RTS		;

MoveSprPos:	;

PHB		;
LDA #$07		; once again, the data bank should be 07/87
PHA		;
PLB		;
LDA $1FD6,x	; low byte of pointer
STA $04		;
LDA $1528,x	; high byte of pointer
STA $05		;

LDA ($04),y	;
AND #$0F	; low byte of the pointed-to address: amount to move the sprite on the X-axis
STA $06		;
LDA ($04),y	;
PLB		;
LSR #4		;
STA $07		;

LDA $D8,x	;
AND #$F0	;
CLC		;
ADC $07		; change the sprite's Y position
STA $D8,x	;

LDA $E4,x	;
AND #$F0	;
CLC		;
ADC $06		; change the sprite's X position
STA $E4,x		;

RTS		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; code for sprite state 02
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

State02:

LDA $9D		; if spites are locked...
BNE Return03	; return

JSL $01802A	; update sprite position

LDA $1540,x	; if the wait timer is set...
BNE Return03	;
LDA $AA,x	;
CMP #$20		; or the sprite speed is less than 20 (actually, between A0 and 1F)...
BMI Return03	;

JSR State00	; return

Return03:		;
RTS		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; graphics routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GrinderGFX:

JSR GetDrawInfo
PHX		; preserve the sprite index
LDX #$03		; 4 tiles to draw

GFXLoop:		;

LDA $00		;
CLC		;
ADC XDisp,x	; set the X displacement of the tile
STA $0300,y	;

LDA $01		;
CLC		;
ADC YDisp,x	; set the Y displacement of the tile
STA $0301,y	;

LDA $14		;
AND #$02	; add 00 or 02 to the tile
ORA #$6C	; the first tile used (the second one is 6E)
STA $0302,y	; silly Nintendo, hardcoding tilemaps is stupid

LDA TileProp,x	;
STA $0303,y	; set the tile properties

INY #4		; increment the OAM index
DEX		; decrement the tilemap index
BPL GFXLoop	;
PLX		; sprite index -> X
LDY #$02		; all tiles were 16x16
LDA #$03		; and 4 tiles were drawn
JSL $01B7B3	;
TYA
STA $15EA,x
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  GetDrawInfo:            ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SEC
       SBC $1A
       STA $00
       CLC
       ADC #$0040
       CMP #$0180
       SEP #$20
       LDA $01
       BEQ +
       LDA #$01
+      STA $15A0,x
       TDC
       ROL
       STA $15C4,x
       BNE .Invalid
       LDA $14D4,x
       XBA
       LDA $1662,x
       AND #$20
       BEQ .CheckOnce
.CheckTwice
       LDA $D8,x
       REP #$21
       ADC #$001C
       SEC
       SBC $1C
       SEP #$20
       LDA $14D4,x
       XBA
       BEQ .CheckOnce
       LDA #$02
.CheckOnce
       STA $186C,x
       LDA $D8,x
       REP #$21
       ADC #$000C
       SEC
       SBC $1C
       SEP #$21
       SBC #$0C
       STA $01
       XBA
       BEQ .OnScreenY
       INC $186C,x
.OnScreenY
       LDY $15EA,x
       RTS

.Invalid
       PLA
       PLA
       RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

;==================
  SpawnSprite:
;==================

       XBA
       LDX #$0B
-      LDA $14C8,x
       BEQ +

       DEX
       BPL -

       SEC
       BRA .no_slot

+      XBA
       STA $9E,x

       TXY
       LDX $15E9
       LDA $E4,x
       STA.w $E4,y
       LDA $14E0,x
       STA $14E0,y
       LDA $D8,x
       STA.w $D8,y
       LDA $14D4,x
       STA $14D4,y

       TYX
       JSL $87F7D2
       BCC +

       LDA $9E,x
       STA $7FAB9E,x
       JSL $8187A7
       LDA #$08
       STA $7FAB10,x

+      LDA #$01
       STA $14C8,x
       CLC
.no_slot
       TXY
       LDX $15E9
       RTS

